#if !defined(AFX_HEADERTOOLBAR_H__D1837C7F_35F7_45A4_932B_774A4A337EAF__INCLUDED_)
#define AFX_HEADERTOOLBAR_H__D1837C7F_35F7_45A4_932B_774A4A337EAF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// HeaderToolbar.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CHeaderToolbar window

class CHeaderToolbar : public CToolBar
{
// Construction
public:
	CHeaderToolbar();

// Attributes
public:

// Operations
public:
	//Background procedures...
	void SetDrawRect(CRect Rect);
	void SetGradient(BOOL Activate);
	void SetGradientStartColor(COLORREF GradientStart);
	void SetGradientEndColor(COLORREF GradientEnd);

	//Text procedures
	void SetWindowText(CString InputText);
	void GetWindowText(CString &OutputText);
	void SetFont(CString FontName);
	void SetFontSize(int NewSize);
	void SetTextCol(COLORREF Col);
	void SetTextShadowCol(COLORREF Col);
	void SetPlaceMent(int Place);

	//Text Marg
	void SetMarg(int NewMarg);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHeaderToolbar)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CHeaderToolbar();

	// Generated message map functions
protected:
	//{{AFX_MSG(CHeaderToolbar)
		// NOTE - the ClassWizard will add and remove member functions here.
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
private:
	//Background drawings...
	CBrush Background;
	COLORREF Start;
	COLORREF End;
	BOOL Gradient;
	
	//Text drawings
	CString Text;
	COLORREF TextColor;
	COLORREF ShadowColor;
	CString Font;
	int Size;
	int Placement;

	int Marg;

	void RedrawWindow();

	//This is the current rect, we must override it because no items are involved...
	CRect DrawRect;
	int Height; //Height is stored, since it is not dynamic!
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HEADERTOOLBAR_H__D1837C7F_35F7_45A4_932B_774A4A337EAF__INCLUDED_)

//This is orignaly the CMemDC class, and it still is. Just renamed!
class CFlickerFree : public CDC {
private:	
	CBitmap		m_bitmap;		// Offscreen bitmap
	CBitmap*	m_oldBitmap;	// bitmap originally found in CMemDC
	CDC*		m_pDC;			// Saves CDC passed in constructor
	CRect		m_rect;			// Rectangle of drawing area.
	BOOL		m_bMemDC;		// TRUE if CDC really is a Memory DC.
public:
	
	CFlickerFree(CDC* pDC, const CRect* pRect = NULL) : CDC()
	{
		ASSERT(pDC != NULL); 

		// Some initialization
		m_pDC = pDC;
		m_oldBitmap = NULL;
		m_bMemDC = !pDC->IsPrinting();

		// Get the rectangle to draw
		if (pRect == NULL) {
			pDC->GetClipBox(&m_rect);
		} else {
			m_rect = *pRect;
		}
		
		if (m_bMemDC) {
			// Create a Memory DC
			CreateCompatibleDC(pDC);
			pDC->LPtoDP(&m_rect);

			m_bitmap.CreateCompatibleBitmap(pDC, m_rect.Width(), m_rect.Height());
			m_oldBitmap = SelectObject(&m_bitmap);
			
			SetMapMode(pDC->GetMapMode());
			pDC->DPtoLP(&m_rect);
			SetWindowOrg(m_rect.left, m_rect.top);
		} else {
			// Make a copy of the relevent parts of the current DC for printing
			m_bPrinting = pDC->m_bPrinting;
			m_hDC       = pDC->m_hDC;
			m_hAttribDC = pDC->m_hAttribDC;
		}

		// Fill background 
		FillSolidRect(m_rect, pDC->GetBkColor());
	}

	
	~CFlickerFree()	
	{		
		if (m_bMemDC) {
			// Copy the offscreen bitmap onto the screen.
			m_pDC->BitBlt(m_rect.left, m_rect.top, m_rect.Width(), m_rect.Height(),
				this, m_rect.left, m_rect.top, SRCCOPY);			
			
			//Swap back the original bitmap.
			SelectObject(m_oldBitmap);		
		} else {
			// All we need to do is replace the DC with an illegal value,
			// this keeps us from accidently deleting the handles associated with
			// the CDC that was passed to the constructor.			
			m_hDC = m_hAttribDC = NULL;
		}	
	}
	
	// Allow usage as a pointer	
	CFlickerFree* operator->() 
	{
		return this;
	}	

	// Allow usage as a pointer	
	operator CFlickerFree*() 
	{
		return this;
	}
};
